/*-- Generic Spell Entity by Asmageddon --*/

local Workingtime; //Time for spell to end
local Charge; //For spells which you can charge (hold mouse button) holds information of charge.
local Caster; //Casting object(ie. Clonk that did cast the spell)
local X,Y,sX,sY; //Target X and Y coordinates(ie. coordinates of mouse cursor of player casting the spell) and start coordinates.
local Power;

public func Definition()
{
  //Declare variables here, example:
  /*
    def["ManaUsage"] = 30;
    def["ManaWorkingUsage"] = 1;
    def["MaxCharge"]=3;
    def["Name"] = "Fireball";
    def["School"]=FIRE;  //FIRE is a constant and =2
    def["MaxCharge"]=3;
    def["Duration"]=20;
  */
}

public func Cast(object pCaster, int ix, int iy, int power, bool IgnoreMP)
{
  /*
    This function sets up local variables, checks if there is enough mana 'inside' caster, substracts it and starts spell.
    In case of not enough mana spell object removes itself.
    This function shall not be modified/overwrited.
    Power is supplied directly as it have to be Clonk Power+Staff Power+Other eventual modifiers;
  */
  if (pCaster->LocalN("Mana") < this["ManaUsage"] || !IgnoreMP) {RemoveObject(); return false;}
  else
  {
    X=ix;
    sX=X;
    Y=iy;
    sY=Y;
    if (power != nil)Power=power;
    else Power = 1;
    Caster=pCaster;
    if (!IgnoreMP)
    {
      Caster->LocalN("Mana")-=this["ManaUsage"];
    }
    Workingtime=this["Duration"];
    StartSpell();
    return true;
  }
}

public func CastEnd(bool cancel)
{
  /*
    Handles ending the spell.
  */
  EndSpell(cancel);
  RemoveObject();
  return true;
}

private func TC()
{
  /*
    Handles working mana usage and/or duration of spell
  */
  if (this["MaxCharge"] > 0 && Charge < this["MaxCharge"]) Charge++;
  if (this["Duration"] != nil && this["Duration"] > 0)
  {
    Workingtime--; //Decreases Workingtime to control how long spell lasts...
    if (Workingtime <= 0) CastEnd(false); //...and ends it when the time passed
  }
  if (this["ManaWorkingUsage"] > 0) 
  {
    if (Caster->LocalN("Mana") < this["ManaWorkingUsage"]) {CastEnd(true);} //Cancels spell if user have got not enough mana
    else { SpellWorking(); }
    Caster->LocalN("Mana")-=this["ManaWorkingUsage"]; //Reduces caster mana by fixed amount.
  }
  else { SpellWorking(); } //If spell is not supposed to end yet it continues working.
}

public func Update(int ix, int iy)
{
  //Should be called by ControlUseHolding and/or ControlUseStop to update X and Y coordinates of cursor, usefull for guided spells or spells in which you define start and end point.
  X=ix;
  Y=iy;
}

private func StartSpell()
{
  /* This is executed when player starts casting(ie.:presses LMB/RMB)
     If duration of spell is different from 0 or nil then it does work independently from caster, and you might want to set up Workingtime variable yourself to make it work longer/shorter depending on some circumstances/power of spell.
  */
}

private func SpellWorking()
{
  /* This is executed while spell is working(ie.:while player is holding mouse button)*/
}

private func EndSpell(bool cancel)
{
  /* Executed when spell ends(ie.:player relases LMB/RMB) */
}
